@echo off
rem THIS SCRIPT MUST BE RUNNING AS ADMINISTRATOR !!!
rem Takes about 15-20 minutes on an already installed CodeTyphon
rem Brought to you by Tony_O_Gallos with love :)

rem -= HERE IS YOUR CONFIG - DO NOT PUT DOUBLE QUOTES AROUND NAMES =-
rem -- Where you will place your VHDs, will be created if needed
set VHDDir=C:\VHD
rem -- Name of the VHD you will create
set VHDName=CodeTyphon-530.vhd
rem -- VHDSize in MB, about 5000 are needed (5GB)
set VHDSize=6000
rem -- Letter of your VHD Drive, needed during creation, not needed later
set VHDDriveLetter=T
rem -- Label of the volume (max 11 characters!!!)
set VHDVolumeLabel=CodeTyphon
rem -- Path and name of the VHD Creation Script (without double quotes)
set CreateVHDScriptFile=c:\VHDCreationScript.txt
set SetupDone=NO
rem -= END OF CONFIG =-

echo === Install CodeTyphon in VHD ===
c:
cd c:\

rem -- Check for user with Administrator privileges
NET SESSION >nul 2>&1
IF %ERRORLEVEL% EQU 0 (
Set _ADMIN=YES
) ELSE (
Set _ADMIN=NO
)
if %_ADMIN%==YES goto CheckSetup
echo !!! This script needs to be running as Administrator. !!!
goto End

rem --Check if the Setup has been validated
:CheckSetup
IF %SetupDone%==NO goto SetupNotDone
goto CheckLetter
:SetupNotDone
echo  !!! The Setup has not been done yet.                                 !!!
echo  !!! Please Edit this file, modify the setup and set SetupDone as YES !!!
goto End

:CheckLetter
rem -- Check if the drive letter is already in use (don't put double quotes !)
IF NOT EXIST %VHDDriveLetter%:\NUL goto FreeLetter
echo  !!! This Drive letter is already in use          !!!
echo  !!! Unmount it or change the letter in the Setup !!!
goto End
:FreeLetter

rem -= Check if a VHD file with the same name already exist =-
IF NOT EXIST "%VHDDir%\%VHDName%" goto VHDCheckOk
echo  !!! The VHD file "%VHDDir%\%VHDName%" already exist - Change the Setup - EXITING !!!
:VHDCheckOk
echo  - VHD file "%VHDDir%\%VHDName%" not present, all ok

rem -= Create the VHD Dir if needed =-
IF EXIST "%VHDDir%" goto VHDDirOk
echo - Create %VHDDir%
mkdir "%VHDDir%" 
:VHDDirOk

rem -= Rename existing CodeTyphon Dir if needed =-
IF EXIST "C:\CodeTyphon\binBase" goto CTInstalled
goto CreateCTDir
:CTInstalled
echo  - Existing install of CodeTyphon Found - Saving it
c:
cd c:\
rename C:\CodeTyphon CodeTyphon.TOG
:CreateCTDir
IF EXIST "C:\CodeTyphon" goto CTDirOk
echo  - Create C:\CodeTyphon
mkdir "C:\CodeTyphon" 
:CTDirOk

rem  -- https://technet.microsoft.com/en-us/magazine/ee872416.aspx
rem  -- Create CreateVHDScriptFile
echo create vdisk file="%VHDDir%\%VHDName%" maximum=%VHDSize% > %CreateVHDScriptFile%
echo attach vdisk                                            >> %CreateVHDScriptFile% 
echo create partition primary                                >> %CreateVHDScriptFile% 
echo format                                                  >> %CreateVHDScriptFile%
echo assign letter=%VHDDriveLetter%                          >> %CreateVHDScriptFile% 
echo assign mount=c:\CodeTyphon                              >> %CreateVHDScriptFile%

echo  - Please wait during the creation of the VHD container.
echo    It takes a bit of time to create it and format it.
diskpart /s %CreateVHDScriptFile%
label %VHDDriveLetter%: %VHDVolumeLabel%
IF EXIST "%CreateVHDScriptFile%" del  %CreateVHDScriptFile%
IF EXIST "%VHDDir%\%VHDName%"    goto VHDCreatedOK
echo  !!! VHD creation failed. Aborting... !!!
goto End
:VHDCreatedOK
echo  - VHD created Ok

echo  - Create "Mirror" directories
mkdir "C:\CodeTyphon\AppData\Roaming\typhon32\"
mkdir "C:\CodeTyphon\AppData\Roaming\typhon64\"
mkdir "C:\CodeTyphon\AppData\Local\Typhon Data Desktop\"

echo  - Move existing config files
cd %APPDATA%
robocopy ".\typhon32" "C:\CodeTyphon\AppData\Roaming\typhon32" *.* /MOVE /E >NUL
robocopy ".\typhon64" "C:\CodeTyphon\AppData\Roaming\typhon64" *.* /MOVE /E >NUL
robocopy ".\..\Local\Typhon Data Desktop" "C:\CodeTyphon\AppData\Local\Typhon Data Desktop" *.* /MOVE /E >NUL

echo  - Linking AppData folders to "Mirrors"
rem  -- %APPDATA% means c:\Users\yourUserName\AppData\Roaming
cd %APPDATA%
mklink /D ".\typhon32\" "c:\CodeTyphon\AppData\Roaming\typhon32\"
mklink /D ".\typhon64\" "c:\CodeTyphon\AppData\Roaming\typhon64\"
cd ..
cd Local
mklink /D ".\Typhon Data Desktop\" "c:\CodeTyphon\AppData\Local\Typhon Data Desktop\"

rem -- Reinject the saved Installed version, if exists
IF NOT EXIST "C:\CodeTyphon.TOG" goto End
echo  - Copying existing installed CodeTyphon in the VHD
echo    It takes A LOT OF TIME, DON'T ABORT !!!
echo    (about 15 minutes, there are more than 60,000 files to copy !)
c:
cd c:\
rem -- Magic command :P
robocopy c:\CodeTyphon.TOG C:\CodeTyphon *.* /MOVE /E >NUL
echo  - ALL DONE ! Think about to make it automount at startup with VHD Attach ;)
:End
